﻿Imports System.Reflection
Imports System.IO
Imports System.Windows.Forms
Imports NCDEnterprise

Partial Class NCDLib
    Partial Class Enterprise

        Public Class ProXR
            Public Class Timers
                Public Shared Function PauseAllTimers(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 0           'Pause All Timers
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function ResumeAllTimers(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 1           'Resume All Timers
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function LoadRunAllTimers(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 2           'LoadRun All Timers
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function ClearAllTimers(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 3           'Clear All Timers
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function PauseSelectedTimer(ByRef ncdObj As NCDEnterprise.NCDController, Timer As Byte)
                    If Timer < 1 Or Timer > 32 Then
                        MsgBox("Timer Value Out of Range")
                        End
                    End If
                    Dim aI(3) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 4           'Pause Selected Timer
                    aI(3) = Timer       'Selected Timer
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function ResumeSelectedTimer(ByRef ncdObj As NCDEnterprise.NCDController, Timer As Byte)
                    If Timer < 1 Or Timer > 32 Then
                        MsgBox("Timer Value Out of Range")
                        End
                    End If
                    Dim aI(3) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 5           'Resume Selected Timer
                    aI(3) = Timer       'Selected Timer
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function LoadRunSelectedTimer(ByRef ncdObj As NCDEnterprise.NCDController, Timer As Byte)
                    If Timer < 1 Or Timer > 32 Then
                        MsgBox("Timer Value Out of Range")
                        End
                    End If
                    Dim aI(3) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 6           'Load Run Selected Timer
                    aI(3) = Timer       'Selected Timer
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function ClearSelectedTimer(ByRef ncdObj As NCDEnterprise.NCDController, Timer As Byte)
                    If Timer < 1 Or Timer > 32 Then
                        MsgBox("Timer Value Out of Range")
                        End
                    End If
                    Dim aI(3) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 7           'Clear Selected Timer
                    aI(3) = Timer       'Selected Timer
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
            End Class

            Public Shared I2CError As String

            Public Class Counters
                Public Shared Function ResetCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Integer)

                    If Counter < 1 Then
                        MsgBox("Counter Cannot be Zero")
                        End
                    End If
                    If Counter > 16 Then
                        MsgBox("Counter Cannot be Greater than 16")
                        End
                    End If

                    Dim aI(3) As Byte

                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 20          'Counters Function
                    aI(2) = 0           'Reset Counter Command 
                    aI(3) = Counter     'Counter to Reset

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)

                    Return rData

                End Function

                Public Shared Function IncreaseCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Integer)

                    If Counter < 1 Then
                        MsgBox("Counter Cannot be Zero")
                        End
                    End If
                    If Counter > 16 Then
                        MsgBox("Counter Cannot be Greater than 16")
                        End
                    End If

                    Dim aI(3) As Byte

                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 20          'Counters Function
                    aI(2) = 1           'Increase Counter Command 
                    aI(3) = Counter     'Counter to Increase

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)

                    Return rData

                End Function

                Public Shared Function DecreaseCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Integer)

                    If Counter < 1 Then
                        MsgBox("Counter Cannot be Zero")
                        End
                    End If
                    If Counter > 16 Then
                        MsgBox("Counter Cannot be Greater than 16")
                        End
                    End If

                    Dim aI(3) As Byte

                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 20          'Counters Function
                    aI(2) = 2           'Decrease Counter Command 
                    aI(3) = Counter     'Counter to Decrease

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)

                    Return rData

                End Function

                Public Shared Function GetCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Integer)

                    If Counter < 1 Then
                        MsgBox("Counter Cannot be Zero")
                        End
                    End If
                    If Counter > 16 Then
                        MsgBox("Counter Cannot be Greater than 16")
                        End
                    End If

                    Dim aI(3) As Byte

                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 20          'Counters Function
                    aI(2) = 3           'Decrease Counter Command 
                    aI(3) = Counter     'Counter to Decrease

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)

                    Return rData

                End Function

            End Class
            Public Class Macros
                Public Shared Function Cancel_All_Macros(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 14          'Macros Function
                    aI(2) = 0           'Cancel Macros Command 
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return rData
                End Function
                Public Shared Function Trigger_Macro(ByRef ncdObj As NCDEnterprise.NCDController, Macro As Byte)
                    If Macro < 1 Or Macro > 32 Then
                        MsgBox("Macro Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 14          'Macros Function
                    aI(2) = Macro       'Macro Number 
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return rData
                End Function
                Public Shared Function Trigger_Macro_Word(ByRef ncdObj As NCDEnterprise.NCDController, MSB As Byte, LSB As Byte)
                    Dim aI(4) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 14          'Macros Function
                    aI(2) = 33          'Macro Word Control Function
                    aI(3) = MSB         'Macro Number MSB 
                    aI(4) = LSB         'Macro Number LSB
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return rData
                End Function
                Public Shared Function Trigger_All_Macros(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 14          'Macros Function
                    aI(2) = 34          'All Macros Number 
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return rData
                End Function
            End Class


            Public Shared Function TurnOnRelay(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte, Relay As Byte, GroupSize As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                If Relay < 1 Or Relay > 16 Then
                    MsgBox("Relay Value is Out of Range")
                    End
                    Exit Function
                End If

                If GroupSize > 15 Then
                    MsgBox("Relay Group Cannot Exceed 15")
                    End
                    Exit Function
                End If


                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 1           'Turn On Relay Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = Relay       'Relay
                aI(6) = GroupSize   'Relay Grouping Option

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)

                Return rData

            End Function
            Public Shared Function TurnOffRelay(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte, Relay As Byte, GroupSize As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                If Relay < 1 Or Relay > 16 Then
                    MsgBox("Relay Value is Out of Range")
                    End
                    Exit Function
                End If

                If GroupSize > 15 Then
                    MsgBox("Relay Group Cannot Exceed 15")
                    End
                    Exit Function
                End If

                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 0           'Turn Off Relay Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = Relay       'Relay 
                aI(6) = GroupSize   'Relay Grouping Option

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function
            Public Shared Function ToggleRelay(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte, Relay As Byte, GroupSize As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                If Relay < 1 Or Relay > 16 Then
                    MsgBox("Relay Value is Out of Range")
                    End
                    Exit Function
                End If

                If GroupSize > 15 Then
                    MsgBox("Relay Group Cannot Exceed 15")
                    End
                    Exit Function
                End If

                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 2           'Toggle Relay Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = Relay       'Relay 
                aI(6) = GroupSize   'Relay Grouping Option

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function PulseRelay(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte, Relay As Byte, GroupSize As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                If Relay < 1 Or Relay > 16 Then
                    MsgBox("Relay Value is Out of Range")
                    End
                    Exit Function
                End If


                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 3           'Pulse Relay Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = Relay       'Relay 
                aI(6) = GroupSize   'Relay Grouping Option


                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function AllOff(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 11           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = 0           'Write LSB
                aI(6) = 0           'Write MSB

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function AllOn(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 11           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = 255         'Write LSB
                aI(6) = 255         'Write MSB

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function Randomize(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 12          'Randomize Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function
            Public Shared Function ReadStatus(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 16          'Read Relay Status
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function EmergencyControl(ByRef ncdObj As NCDEnterprise.NCDController, Status As Byte)

                Dim aI(2) As Byte

                aI(0) = 253         'Relay Control Functions
                aI(1) = 17          'Emergency Control Command
                aI(2) = Status       '1 = All On, Anything Else = All Off

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                Return rData

            End Function


            Public Shared Function RelayRefreshing(ByRef ncdObj As NCDEnterprise.NCDController, RefreshOption As Byte)

                Dim aI(2) As Byte

                aI(0) = 253                 'Relay Control Functions
                aI(1) = 18                  'Relay Refreshing
                aI(2) = RefreshOption       '0 = Standard Refresh, 1 = Refresh Relays on All Banks
                '2 = AutoRefresh Off, 3 = AutoRefresh On

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                Return rData

            End Function

            Public Shared Function StoreAsPowerUpDefault(ByRef ncdObj As NCDEnterprise.NCDController)

                Dim aI(1) As Byte

                aI(0) = 253             'Relay Control Functions
                aI(1) = 19              'Store as Power-Up Default State

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)

                Debug.Print("Store Result: " + rData(0).ToString)

                Return rData

            End Function



            Public Shared Function Invert(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 4           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function


            Public Shared Function Reverse(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 5           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function


            Public Shared Function ShiftLeft(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 6           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function ShiftRight(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 7           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function


            Public Shared Function Reverse_8(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 8           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function


            Public Shared Function ShiftLeft_8(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 9           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function ShiftRight_8(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 10           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function


            ' Public Shared Function EncryptionOnOff(ByRef ncdObj As NCDEnterprise.NCDController, Data As Array)
            '     If Data(0) = 0 Then
            '         Debug.Print("Changing Encryption to Off:" + Data.ToString)
            '     Else
            '         Debug.Print("Changing Encryption to On:" + Data.ToString)
            '     End If
            '     NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 825, Data)
            '     Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
            '     Debug.Print(Result)
            '     Return Result
            ' End Function

            Public Shared Function GetRelayStatus(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Get Relay Status -----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------

                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(5) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim Location As Integer = 0 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                aI(0) = 254
                aI(1) = 52
                aI(2) = MSB
                aI(3) = LSB

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                aI(4) = 16
                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)
                '  Debug.Print("-------------- Data Returned:")
                '  For Each a In rData
                '      Debug.Print(a)
                '  Next
                '  Debug.Print("-------------- END Data Returned")

                Return rData

            End Function
            Public Shared Function PutRelayStatus(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, RelayStatusData As Array)

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Put Relay Status -----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------


                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(20) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayStatusData.Length <> 16 Then
                    MsgBox("RelayStatus Data Array is Not 16 Bytes Long: " + RelayStatusData.Length.ToString)
                    End
                    Exit Function
                End If

                Dim Location As Integer = 0 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                aI(0) = 254
                aI(1) = 53
                aI(2) = MSB
                aI(3) = LSB
                aI(4) = RelayStatusData(0)
                aI(5) = RelayStatusData(1)
                aI(6) = RelayStatusData(2)
                aI(7) = RelayStatusData(3)
                aI(8) = RelayStatusData(4)
                aI(9) = RelayStatusData(5)
                aI(10) = RelayStatusData(6)
                aI(11) = RelayStatusData(7)
                aI(12) = RelayStatusData(8)
                aI(13) = RelayStatusData(9)
                aI(14) = RelayStatusData(10)
                aI(15) = RelayStatusData(11)
                aI(16) = RelayStatusData(12)
                aI(17) = RelayStatusData(13)
                aI(18) = RelayStatusData(14)
                aI(19) = RelayStatusData(15)

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)
                ' Debug.Print("-------------- Data Returned:")
                ' For Each a In rData
                '     Debug.Print(a)
                ' Next
                ' Debug.Print("-------------- END Data Returned")
            End Function

            Public Shared Function GetRelayRecord(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Get Relay Record -----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------

                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(5) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayRecord Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim Location As Integer = 256 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                aI(0) = 254
                aI(1) = 52
                aI(2) = MSB
                aI(3) = LSB
                aI(4) = 16

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)

                If (Not (rData Is Nothing)) Then
                    Debug.Print("-------------- Data Returned:")
                    For Each a In rData
                        Debug.Print(a)
                    Next
                    Debug.Print("-------------- END Data Returned")
                End If

                Return rData


            End Function
            Public Shared Function PutRelayRecord(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, RelayRecordData As Array)

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Put Relay Record -----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------

                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(20) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayRecord Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayRecordData.Length <> 16 Then
                    MsgBox("RelayRecord Data Array is Not 16 Bytes Long: " + RelayRecordData.Length.ToString)
                    End
                    Exit Function
                End If

                Dim Location As Integer = 256 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                aI(0) = 254
                aI(1) = 53
                aI(2) = MSB
                aI(3) = LSB
                aI(4) = RelayRecordData(0)
                aI(5) = RelayRecordData(1)
                aI(6) = RelayRecordData(2)
                aI(7) = RelayRecordData(3)
                aI(8) = RelayRecordData(4)
                aI(9) = RelayRecordData(5)
                aI(10) = RelayRecordData(6)
                aI(11) = RelayRecordData(7)
                aI(12) = RelayRecordData(8)
                aI(13) = RelayRecordData(9)
                aI(14) = RelayRecordData(10)
                aI(15) = RelayRecordData(11)
                aI(16) = RelayRecordData(12)
                aI(17) = RelayRecordData(13)
                aI(18) = RelayRecordData(14)
                aI(19) = RelayRecordData(15)

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)
                ' Debug.Print("-------------- Data Returned:")
                ' For Each a In rData
                '     Debug.Print(a)
                ' Next
                ' Debug.Print("-------------- END Data Returned")
            End Function

            Public Shared Function GetRelayAddress(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Get Relay Address ----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------

                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(5) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayRecord Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim Location As Integer = 512 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                aI(0) = 254
                aI(1) = 52
                aI(2) = MSB
                aI(3) = LSB
                aI(4) = 16

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)

                If rData IsNot Nothing Then
                    Debug.Print("-------------- Data Returned:")
                    For Each a In rData
                        Debug.Print(a)
                    Next
                    Debug.Print("-------------- END Data Returned")
                End If

                Return rData


            End Function
            Public Shared Function PutRelayAddress(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, RelayStatusData As Array)

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Put Relay Address ----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------


                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(20) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayStatusData.Length <> 16 Then
                    MsgBox("RelayStatus Data Array is Not 16 Bytes Long: " + RelayStatusData.Length.ToString)
                    End
                    Exit Function
                End If

                Dim Location As Integer = 512 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                aI(0) = 254
                aI(1) = 53
                aI(2) = MSB
                aI(3) = LSB
                aI(4) = RelayStatusData(0)
                aI(5) = RelayStatusData(1)
                aI(6) = RelayStatusData(2)
                aI(7) = RelayStatusData(3)
                aI(8) = RelayStatusData(4)
                aI(9) = RelayStatusData(5)
                aI(10) = RelayStatusData(6)
                aI(11) = RelayStatusData(7)
                aI(12) = RelayStatusData(8)
                aI(13) = RelayStatusData(9)
                aI(14) = RelayStatusData(10)
                aI(15) = RelayStatusData(11)
                aI(16) = RelayStatusData(12)
                aI(17) = RelayStatusData(13)
                aI(18) = RelayStatusData(14)
                aI(19) = RelayStatusData(15)

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)
                '  Debug.Print("-------------- Data Returned:")
                '  For Each a In rData
                '  Debug.Print(a)
                '  Next
                '  Debug.Print("-------------- END Data Returned")

            End Function
        End Class

    End Class



End Class
