﻿Imports System.Reflection
Imports System.IO
Imports System.Windows.Forms
Imports NCDEnterprise

Partial Class NCDLib
    Public Class Enterprise
        Public Class System

            Public Class Alarm
                Public Shared Function State(ByRef ncdObj As NCDEnterprise.NCDController, Alarm As Byte)

                    If Alarm > 0 Then
                        Alarm = 1
                    End If
                    Dim aI(1) As Byte

                    aI(0) = 194         'Alarm Control
                    aI(1) = Alarm       'Control Alarm

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                    Return rData

                End Function
            End Class

            Public Class NumberCounters
                Public Shared Function IncreaseCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Control
                    aI(2) = 0           'Increase Counter Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
                Public Shared Function DecreaseCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Control
                    aI(2) = 1           'Decrease Counter Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
                Public Shared Function SetCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte, UInt As UInteger) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(6) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Control
                    aI(2) = 2           'Set Counter Value Function
                    aI(3) = NCDLib.Math.GetMSB32_LSW_LSB(UInt)   'Set Value LSW_LSB = Least Significant Word, Least Significant Byte
                    aI(4) = NCDLib.Math.GetMSB32_LSW_MSB(UInt)   'Set Value LSW_MSB = Least Significant Word, Most Significant Byte
                    aI(5) = NCDLib.Math.GetMSB32_MSW_LSB(UInt)   'Set Value MSW_LSB = Most Significant Word, Least Significant Byte
                    aI(6) = NCDLib.Math.GetMSB32_MSW_MSB(UInt)   'Set Value MSW_MSB = Most Significant Word, Most Significant Byte
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function

                Public Shared Function ReadCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Read
                    aI(2) = 3           'Get Counter Value Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
                Public Shared Function ResetCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Read
                    aI(2) = 4           'Clear Counter Value Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
            End Class
            Public Class Diagnostics

                Public Shared Function Read(ByRef ncdObj As NCDEnterprise.NCDController) As Byte()

                    Dim I(1) As Byte

                    I(0) = 189                'Byte 0
                    I(1) = 0                  'Byte 1

                    NCDLib.WriteBytesAPI(ncdObj, True, I)

                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    'If (Not (rData Is Nothing)) Then

                    Return rData

                    'End If

                End Function

                Public Shared Function ClearI2CPorts(ByRef ncdObj As NCDEnterprise.NCDController) As Byte()
                    Dim I(2) As Byte

                    I(0) = 189                'Byte 0
                    I(1) = 0                  'Byte 1
                    I(2) = 85                 'Reset I2C Ports Command

                    NCDLib.WriteBytesAPI(ncdObj, True, I)

                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    'If (Not (rData Is Nothing)) Then

                    Return rData

                    'End If
                End Function

                Public Shared Function InitI2CPorts(ByRef ncdObj As NCDEnterprise.NCDController) As Byte()
                    Dim I(2) As Byte

                    I(0) = 189                'Byte 0
                    I(1) = 0                  'Byte 1
                    I(2) = 86                 'Reset I2C Ports Command

                    NCDLib.WriteBytesAPI(ncdObj, True, I)

                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    'If (Not (rData Is Nothing)) Then

                    Return rData

                    'End If
                End Function

            End Class
        End Class

        Public Class E3C
            Public Shared Sub EnableAllDevices(ByRef ncdObj As NCDEnterprise.NCDController)
                Dim aI(1) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 248         'Enable All Devices
                NCDLib.WriteBytesAPI(ncdObj, True, aI)
            End Sub
            Public Shared Sub DisableAllDevices(ByRef ncdObj As NCDEnterprise.NCDController)
                Dim aI(1) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 249         'Disable All Devices
                NCDLib.WriteBytesAPI(ncdObj, True, aI)
            End Sub
            Public Shared Function EnableSelectedDevice(ByRef ncdObj As NCDEnterprise.NCDController, Device As Byte)
                Dim aI(2) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 252         'Enable a Specific Device Command
                aI(2) = Device      'Device to Enable
                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)      'Device will E3C Device Number
                Return rData
            End Function
        End Class

        Public Class Setup
            ' Public Class Process
            '     Public Shared Function Change_to_Baud(ByRef ncdobj As NCD.NCDComponent, Port As Integer, Baud As Array)
            '
            '         Change_to_Baud = False
            '         'Go into Configuration Mode
            '         NCDLib.Enterprise.Setup.ConfigurationMode(ncdobj, 10)
            '         NCDLib.Enterprise.Setup.Change.Baud_Rate(ncdobj, Port, Baud)
            '         NCDLib.Enterprise.Setup.ConfigurationMode(ncdobj, 0)
            '         NCDLib.Enterprise.Setup.Reboot_Soft(ncdobj)
            '         Change_to_Baud = True
            '         Return Change_to_Baud
            '
            '     End Function
            ' End Class
            Public Class Change
                Public Shared Function BaudChipValueToText(Setting As Integer)

                    Debug.Print("CHIP TO UI: " + Setting.ToString)

                    Select Case Setting
                        Case 0
                            BaudChipValueToText = "9600 Baud -0.08% Timing Error"
                        Case 1
                            BaudChipValueToText = "19.2K Baud +0.16% Timing Error"
                        Case 2
                            BaudChipValueToText = "38.4K Baud +0.16% Timing Error"
                        Case 3
                            BaudChipValueToText = "57.6K Baud -0.79% Timing Error"
                        Case 4
                            BaudChipValueToText = "115.2K Baud -0.79% Timing Error (Default)"
                        Case 5
                            BaudChipValueToText = "230.4K Baud +2.12% Timing Error"
                        Case 6
                            BaudChipValueToText = "250,000 Baud 0.00% Timing Error (USB Only)"
                        Case 7
                            BaudChipValueToText = "266,660 Baud 0.00% Timing Error (USB Only)"
                        Case 8
                            BaudChipValueToText = "285,710 Baud 0.00% Timing Error (USB Only)"
                        Case 9
                            BaudChipValueToText = "307,700 Baud 0.00% Timing Error (USB Only)"
                        Case 10
                            BaudChipValueToText = "333,330 Baud 0.00% Timing Error (USB Only)"
                        Case 11
                            BaudChipValueToText = "363,620 Baud 0.00% Timing Error (USB Only)"
                        Case 12
                            BaudChipValueToText = "400,000 Baud 0.00% Timing Error (USB Only)"
                        Case 13
                            BaudChipValueToText = "500,000 Baud 0.00% Timing Error (USB Only)"
                        Case 14
                            BaudChipValueToText = "571,410 Baud 0.00% Timing Error (USB Only)"
                        Case 15
                            BaudChipValueToText = "666,660 Baud 0.00% Timing Error (USB Only)"
                        Case 16
                            BaudChipValueToText = "800,000 Baud 0.00% Timing Error (USB Only)"
                        Case 17
                            BaudChipValueToText = "1,000,000 Baud 0.00% Timing Error (USB Only)"
                        Case Else
                            BaudChipValueToText = "115.2K Baud -0.79% Timing Error (Default)"
                    End Select

                End Function
                Public Shared Function BaudTextToChipValue(Setting As String)

                    Select Case Setting
                        Case "9600 Baud -0.08% Timing Error"
                            BaudTextToChipValue = 0
                        Case "19.2K Baud +0.16% Timing Error"
                            BaudTextToChipValue = 1
                        Case "38.4K Baud +0.16% Timing Error"
                            BaudTextToChipValue = 2
                        Case "57.6K Baud -0.79% Timing Error"
                            BaudTextToChipValue = 3
                        Case "115.2K Baud -0.79% Timing Error (Default)"
                            BaudTextToChipValue = 4
                        Case "230.4K Baud +2.12% Timing Error"
                            BaudTextToChipValue = 5
                        Case "250,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 6
                        Case "266,660 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 7
                        Case "285,710 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 8
                        Case "307,700 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 9
                        Case "333,330 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 10
                        Case "363,620 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 11
                        Case "400,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 12
                        Case "500,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 13
                        Case "571,410 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 14
                        Case "666,660 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 15
                        Case "800,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 16
                        Case "1,000,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 17
                        Case Else
                            BaudTextToChipValue = 4
                    End Select

                End Function
                Public Shared Function Baud_Rate(ByRef ncdObj As NCDEnterprise.NCDController, Port As Integer, NewBaudRate As Array)
                    Debug.Print("Changing Baud Rate - Port: " + Port.ToString + "  Baud:" + NewBaudRate.ToString)
                    If NewBaudRate(0) > 17 Then
                        NewBaudRate(0) = 4
                    End If
                    If Port = 1 Then
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 831, NewBaudRate)
                    Else
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 829, NewBaudRate)
                    End If
                    'NCDLib.WriteBytesAPI(ncdObj, True, command)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
                Public Shared Function Communication_Technology(ByRef ncdObj As NCDEnterprise.NCDController, NewTechnology As Array)
                    Debug.Print("Changing Baud Rate - Technology:" + NewTechnology.ToString)
                    If NewTechnology(0) > 6 Then
                        NewTechnology(0) = 6
                    End If
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 828, NewTechnology)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function

                Public Shared Function E3C_Device_Number(ByRef ncdObj As NCDEnterprise.NCDController, Data As Array)
                    Debug.Print("Changing E3C Device Number:" + Data.ToString)
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 827, Data)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function

                Public Shared Function NodeID(ByRef ncdObj As NCDEnterprise.NCDController, Data As Array)
                    Debug.Print("Changing NodeID:" + Data.ToString)
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 826, Data)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
                Public Shared Function EncryptionOnOff(ByRef ncdObj As NCDEnterprise.NCDController, Data As Array)
                    If Data(0) = 0 Then
                        Debug.Print("Changing Encryption to Off:" + Data.ToString)
                    Else
                        Debug.Print("Changing Encryption to On:" + Data.ToString)
                    End If
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 825, Data)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
                Public Shared Function EncryptionKey(ByRef ncdObj As NCDEnterprise.NCDController, Key As Array)
                    Debug.Print("Changing Encryption Key:" + Key.ToString)
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 896, Key)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
            End Class
            Public Shared Function Identify(ByRef ncdobj As NCDController) As String

                Try
                    Dim Result As Array = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, False, 832, 31)
                    Dim Identity As String = "Unknown"
                    If Result.Length = 32 Then
                        Identity = ""
                        'Expand Parcer to Identify Devices by their Function
                        If Result(1) > 0 Then
                            Identity = Identity + "ASM" + Result(1).ToString + "-" + Result(2).ToString + Chr(13) + Chr(10)
                        End If
                        If Result(3) > 0 Then
                            Identity = Identity + "PR" + Result(3).ToString + "-" + Result(4).ToString + " "
                        End If
                        If Result(5) > 0 Then
                            Identity = Identity + "PR" + Result(5).ToString + "-" + Result(6).ToString + " "
                        End If
                        If Result(7) > 0 Then
                            Identity = Identity + "PR" + Result(7).ToString + "-" + Result(8).ToString + " "
                        End If
                        If Result(9) > 0 Then
                            Identity = Identity + "PR" + Result(9).ToString + "-" + Result(10).ToString + " "
                        End If
                        If Result(11) > 0 Then
                            Identity = Identity + "PR" + Result(11).ToString + "-" + Result(12).ToString + " "
                        End If
                        If Result(13) > 0 Then
                            Identity = Identity + "PR" + Result(13).ToString + "-" + Result(14).ToString + " "
                        End If
                        If Result(15) > 0 Then
                            Identity = Identity + "PR" + Result(15).ToString + "-" + Result(16).ToString + " " + Chr(13) + Chr(10)
                        End If
                        If Result(17) > 0 Then
                            Identity = Identity + "PR" + Result(17).ToString + "-" + Result(18).ToString + " "
                        End If
                        If Result(19) > 0 Then
                            Identity = Identity + "PR" + Result(19).ToString + "-" + Result(20).ToString + " "
                        End If
                        If Result(21) > 0 Then
                            Identity = Identity + "PR" + Result(21).ToString + "-" + Result(22).ToString + " "
                        End If
                        If Result(23) > 0 Then
                            Identity = Identity + "PR" + Result(23).ToString + "-" + Result(24).ToString + " "
                        End If
                        If Result(25) > 0 Then
                            Identity = Identity + "PR" + Result(25).ToString + "-" + Result(26).ToString + " "
                        End If
                        If Result(27) > 0 Then
                            Identity = Identity + "PR" + Result(27).ToString + "-" + Result(28).ToString + " "
                        End If
                        Identity = Identity + Chr(13) + Chr(10)
                        'Calculate Version Display
                        Identity = Identity + "Version " + Result(29).ToString + "." + Result(30).ToString + " 20" + Result(31).ToString
                    End If
                    Return Identity
                Catch
                    'MsgBox("Unable to Open Selected Communications Port.")
                    'End
                    Return "None"
                End Try
                'Return True
            End Function
            Public Shared Function LookupI2CSpeed(Speed As Integer) As String
                LookupI2CSpeed = "XXXKHz"
                Select Case Speed
                    Case <= 0 : Return "60KHz"
                    Case <= 1 : Return "100KHz"
                    Case <= 2 : Return "200KHz"
                    Case <= 3 : Return "300KHz"
                    Case <= 4 : Return "400KHz"
                    Case <= 5 : Return "506KHz"
                    Case <= 6 : Return "602KHz"
                    Case <= 7 : Return "708KHz"
                    Case <= 8 : Return "708KHz"
                    Case <= 9 : Return "708KHz"
                    Case <= 10 : Return "708KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 11 : Return "679KHz"
                    Case <= 12 : Return "651KHz"
                    Case <= 13 : Return "629KHz"
                    Case <= 14 : Return "602KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 15 : Return "583KHz"
                    Case <= 18 : Return "526KHz"
                    Case <= 19 : Return "506KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 20 : Return "492KHz"
                    Case <= 25 : Return "427KHz"
                    Case <= 27 : Return "403KHz"
                    Case <= 28 : Return "400KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 30 : Return "375KHz"
                    Case <= 35 : Return "336KHz"
                    Case <= 40 : Return "305KHz"
                    Case <= 41 : Return "300KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 45 : Return "279KHz"
                    Case <= 55 : Return "238KHz"
                    Case <= 65 : Return "206KHz"
                    Case <= 66 : Return "204KHz"
                    Case <= 67 : Return "200KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 68 : Return "198KHz"
                    Case <= 70 : Return "194KHz"
                    Case <= 75 : Return "184KHz"
                    Case <= 85 : Return "164KHz"
                    Case <= 95 : Return "149KHz"
                    Case <= 105 : Return "136KHz"
                    Case <= 115 : Return "125KHz"
                    Case <= 125 : Return "116KHz"
                    Case <= 135 : Return "108KHz"
                    Case <= 145 : Return "102KHz"
                    Case <= 147 : Return "100KHz" '''''''''''''''''''''''''''''''''''
                    Case <= 155 : Return "96KHz"
                    Case <= 165 : Return "90KHz"
                    Case <= 175 : Return "85KHz"
                    Case <= 185 : Return "81KHz"
                    Case <= 195 : Return "77KHz"
                    Case <= 205 : Return "74KHz"
                    Case <= 215 : Return "70KHz"
                    Case <= 225 : Return "67KHz"
                    Case <= 235 : Return "65KHz"
                    Case <= 245 : Return "62KHz"
                    Case <= 253 : Return "60KHz"
                    Case <= 255 : Return "60KHz"
                End Select



            End Function

            Public Shared Function GetConfiguration(ByRef ncdobj As NCDController)
                'Dim Configuration As Array = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, False, 768, 63)

                Dim ConfigurationLo As Array = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, False, 768, 31)
                Dim ConfigurationHi As Array = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, False, 800, 31)

                If ConfigurationLo.Length = 32 And ConfigurationHi.Length = 32 Then
                    Dim Configuration(63) As Byte
                    Dim Temp As Byte
                    For Temp = 0 To 31
                        Configuration(Temp) = ConfigurationLo(Temp)
                        Configuration(Temp + 32) = ConfigurationHi(Temp)
                    Next
                    Return Configuration
                End If

            End Function

            Public Shared Function DeviceActivated(ByRef ncdobj As NCDController) As Boolean

                'Address 7728 I(0)  = "32-Bit System Minutes Counter 1 Byte 0 LSWord LSByte"
                'Address 7729 I(1)  = "32-Bit System Minutes Counter 1 Byte 1 LSWord MSByte"
                'Address 7730 I(2)  = "32-Bit System Minutes Counter 1 Byte 2 MSWord LSByte"
                'Address 7731 I(3)  = "32-Bit System Minutes Counter 1 Byte 3 MSWord MSByte"
                'Address 7732 I(4)  = "32-Bit NCD Online Invoice Number 1 Byte 0 LSWord LSByte"
                'Address 7733 I(5)  = "32-Bit NCD Online Invoice Number 1 Byte 1 LSWord MSByte"
                'Address 7734 I(6)  = "32-Bit NCD Online Invoice Number 1 Byte 2 MSWord LSByte"
                'Address 7735 I(7)  = "32-Bit NCD Online Invoice Number 1 Byte 3 MSWord MSByte"
                'Address 7736 I(8)  = "Activation Month"
                'Address 7737 I(9)  = "Activation Day"
                'Address 7738 I(10) = "Activation Year"
                'Address 7739 I(11) = "Activation Hours"
                'Address 7740 I(12) = "Activation Minutes"
                'Address 7741 I(13) = "Activation Seconds"
                'Address 7742 I(14) = "Activation Engineer"
                'Address 7743 I(15) = "Reserved Activation"

Retry:
                Debug.Print("Device Activated Function Call")
                Try
                    DeviceActivated = True
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, True, 7728, 16)
                    If I IsNot Nothing Then
                        If I.Length = 15 Then
                            If I(15) = 0 Then
                                DeviceActivated = False
                            End If
                        End If
                    Else
                        ' GoTo Retry
                    End If
                Catch
                    '  GoTo Retry
                End Try

            End Function


            Public Shared Function ActivateDevice(ByRef ncdobj As NCDController, Invoice As UInteger) As Boolean

                ActivateDevice = False

                'Address 7728 I(0)  = "32-Bit System Minutes Counter 1 Byte 0 LSWord LSByte"
                'Address 7729 I(1)  = "32-Bit System Minutes Counter 1 Byte 1 LSWord MSByte"
                'Address 7730 I(2)  = "32-Bit System Minutes Counter 1 Byte 2 MSWord LSByte"
                'Address 7731 I(3)  = "32-Bit System Minutes Counter 1 Byte 3 MSWord MSByte"
                'Address 7732 I(4)  = "32-Bit NCD Online Invoice Number 1 Byte 0 LSWord LSByte"
                'Address 7733 I(5)  = "32-Bit NCD Online Invoice Number 1 Byte 1 LSWord MSByte"
                'Address 7734 I(6)  = "32-Bit NCD Online Invoice Number 1 Byte 2 MSWord LSByte"
                'Address 7735 I(7)  = "32-Bit NCD Online Invoice Number 1 Byte 3 MSWord MSByte"
                'Address 7736 I(8)  = "Activation Month"
                'Address 7737 I(9)  = "Activation Day"
                'Address 7738 I(10) = "Activation Year"
                'Address 7739 I(11) = "Activation Hours"
                'Address 7740 I(12) = "Activation Minutes"
                'Address 7741 I(13) = "Activation Seconds"
                'Address 7742 I(14) = "Reserved Activation"
                'Address 7743 I(15) = "Reserved Activation"

                If NCDLib.Enterprise.Setup.DeviceActivated(ncdobj) = True Then
                    MsgBox("Device has Already been Activated and Cannot be Activated Again.")
                    Return ActivateDevice
                End If


                Dim aI(15) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 33          'Test 2-Way Command
                aI(2) = 188         'Special Command Mode
                aI(3) = 199         'Special Command Mode
                aI(4) = 222         'Special Command Mode for Device Activation
                aI(5) = NCDLib.Math.GetMSB32_LSW_LSB(Invoice)   'Set Value LSW_LSB = Least Significant Word, Least Significant Byte
                aI(6) = NCDLib.Math.GetMSB32_LSW_MSB(Invoice)   'Set Value LSW_MSB = Least Significant Word, Most Significant Byte
                aI(7) = NCDLib.Math.GetMSB32_MSW_LSB(Invoice)   'Set Value MSW_LSB = Most Significant Word, Least Significant Byte
                aI(8) = NCDLib.Math.GetMSB32_MSW_MSB(Invoice)   'Set Value MSW_MSB = Most Significant Word, Most Significant Byte
                aI(9) = Date.Today.Month 'Month
                aI(10) = Date.Today.Day 'Day
                aI(11) = (Date.Today.Year - 2000)    'Year
                aI(12) = TimeOfDay.Hour              'Hours
                aI(13) = TimeOfDay.Minute            'Minutes
                aI(14) = TimeOfDay.Second           'Seconds
                aI(15) = 0  'Engineer

                NCDLib.WriteBytesAPI(ncdobj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdobj, True, 2)      'Device will E3C Device Number

                If rData(0) = 0 Then
                    ActivateDevice = True
                End If

                Return ActivateDevice

            End Function

            Public Shared Function PutConfiguration(ByRef ncdobj As NCDController, Configuration As Array)

                Debug.Print("Storing Configuration...")
                Dim Data(63) As Byte
                For N As Integer = 0 To (Configuration.Length - 1)
                    Data(N) = Configuration(N)
                    Debug.Print(Data(N).ToString)
                Next
                Debug.Print("End Debug Data")

                Dim ConfigurationLo(31) As Byte
                Dim ConfigurationHi(31) As Byte
                Dim Temp As Byte
                For Temp = 0 To 31
                    ConfigurationLo(Temp) = Configuration(Temp)
                    ConfigurationHi(Temp) = Configuration(Temp + 32)
                Next

                'NCDLib.Enterprise.Setup.EEPROM_Write(ncdobj, False, 768, Data) 'Original Stores 64 Bytes

                NCDLib.Enterprise.Setup.EEPROM_Write(ncdobj, False, 768, ConfigurationLo) 'Store Lower 32 Bytes
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdobj, True)
                Debug.Print(Result)
                NCDLib.Enterprise.Setup.EEPROM_Write(ncdobj, False, 800, ConfigurationHi) 'Store Upper 32 Bytes
                Dim Result2 As Integer = NCDLib.ReadByteAPI(ncdobj, True)
                Debug.Print(Result2)
                Return Result2

            End Function

            Public Shared Function PutEncryption(ByRef ncdobj As NCDController, Key As Array)

                'Debug.Print("Storing Configuration...")
                Dim Data(Key.Length - 1) As Byte
                Data(0) = Key.Length - 1
                For N As Integer = 1 To (Key.Length - 1)
                    Data(N) = Key(N)
                    Debug.Print(Data(N).ToString)
                Next
                'Debug.Print("End Debug Data")
                NCDLib.Enterprise.Setup.EEPROM_Write(ncdobj, False, 896, Data)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdobj, True)
                'Debug.Print(Result)
                Return Result

            End Function

            Public Shared Sub Reboot_Soft(ByRef ncdObj As NCDController)
                'Issue Soft Reboot Command
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 140, 99)
            End Sub
            Public Shared Sub Reboot_Hard(ByRef ncdObj As NCDController)
                'Issure Hard Reboot Command
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 140, 199)
            End Sub
            Public Shared Function Test2Way(ByRef ncdObj As NCDController)
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function
            Public Shared Function ConfigurationMode(ByRef ncdObj As NCDController, Duration As Integer)
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 140, 86, Duration)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function
            Public Shared Function RecoverDefaultSettings(ByRef ncdObj As NCDController) As Integer
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 188, 199, 244)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function
            Public Shared Function EEPROM_Write(ByRef ncdObj As NCDController, External As Boolean, Location As Integer, ByVal Data As Array)

                'External = False (On-Board CPU EEPROM)
                'External = True (Off-Board External EEPROM)
                'Location = Memory Location
                'Data = Byte Array to Write to Memory

                Dim _Data As New ArrayList

                _Data.Add(254)
                If External = False Then
                    _Data.Add(51)
                Else
                    _Data.Add(53)
                End If

                _Data.Add(NCDLib.Math.GetMSB(Location))
                _Data.Add(NCDLib.Math.GetLSB(Location))
                _Data.AddRange(Data)

                'Send API Frame to Device
                'im d As Byte() = CType(API.ToArray(GetType(Byte)), Byte())
                Dim d(_Data.Count - 1) As Byte
                For i = 0 To _Data.Count - 1
                    d(i) = _Data(i)
                Next


                ''''
                '''
                'Debug.Print("------------COMMAND DUMP-----")
                'For I = 0 To _Data.Count
                ' Debug.Print(I.ToString + " ---->" + _Data(I).ToString)
                ' Next
                'Debug.Print("------------END COMMAND DUMP-----")

                NCDLib.WriteBytesAPI(ncdObj, True, d)

                ' NCDLib.WriteBytesAPI(ncdObj, True, 254, 50, NCDLib.Math.GetMSB(Location), NCDLib.Math.GetLSB(Location), d)

                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function

            Public Shared Function EEPROM_Read(ByRef ncdObj As NCDController, External As Boolean, Location As Integer, Bytes As Integer) As Array

                'External = False (On-Board CPU EEPROM)
                'External = True (Off-Board External EEPROM)
                'Location = Memory Location
                'Data = Byte Array to Write to Memory

                Dim _Command As New ArrayList

                _Command.Add(254)
                If External = False Then
                    _Command.Add(50)
                Else
                    _Command.Add(52)
                End If
                _Command.Add(NCDLib.Math.GetMSB(Location))
                _Command.Add(NCDLib.Math.GetLSB(Location))
                _Command.Add(Bytes)

                'Send API Frame to Device
                'im d As Byte() = CType(API.ToArray(GetType(Byte)), Byte())

                Debug.Print("Reading EEPROM:")
                Dim d(_Command.Count - 1) As Byte
                For i = 0 To (_Command.Count - 1)
                    d(i) = _Command(i)
                    Debug.Print(d(i).ToString)
                Next
                Debug.Print("End Reading EEPROM")

                NCDLib.WriteBytesAPI(ncdObj, True, d)

                ' NCDLib.WriteBytesAPI(ncdObj, True, 254, 50, NCDLib.Math.GetMSB(Location), NCDLib.Math.GetLSB(Location), d)

                Dim Result As Array = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)

                'Debug.Print(Result)
                Return Result
            End Function
        End Class


        Public Class Device
            Public Class PR53_25
                Public Shared Function StorePowerUpDefaultOptions(ByRef ncdObj As NCDEnterprise.NCDController, RecoveryMethod As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7600, 16)
                    If I IsNot Nothing Then
                        Dim Menu As Byte = RecoveryMethod << 6      'Or Data Into I(8) so MSB Can be Used
                        Dim Value As Byte = (I(8) And 63)
                        I(8) = Menu Or Value 'Merge Menu and Values Together in I(8)
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7600, I)
                    End If
                End Function
                Public Shared Function StorePowerUpDefaultState(ByRef ncdObj As NCDEnterprise.NCDController, DAC1 As Integer, DAC2 As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7600, 16)
                    If I IsNot Nothing Then
                        Dim Menu As Byte = 2 << 6      'Or Data Into I(8) so MSB Can be Used
                        Dim Value As Byte = NCDLib.Math.GetMSB(DAC1)
                        I(8) = Menu Or Value 'Merge Menu and Values Together in I(8)
                        I(9) = NCDLib.Math.GetLSB(DAC1)
                        I(10) = NCDLib.Math.GetMSB(DAC2)
                        I(11) = NCDLib.Math.GetLSB(DAC2)
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7600, I)
                    End If
                End Function
                Public Shared Function SetOutputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Value As Integer)
                    Dim Options As Byte = 128 'Write Option
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 2 Then StartChannel = 2
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 2 Then StopChannel = 2
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 25, StartChannel, StopChannel, Options, NCDLib.Math.GetMSB(Value), NCDLib.Math.GetLSB(Value))
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 2 Then StartChannel = 2
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 2 Then StopChannel = 2
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 25, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Decimal = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Scale = 0 Then
                        Calculation = RealWord * 0.0014015416958655
                    Else
                        Calculation = RealWord * (0.0014015416958655 / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " mA"
                End Function
            End Class
            Public Class PR53_6
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 6, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Integer = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Scale = 0 Then
                        Calculation = RealWord * 0.0013568521031208
                    Else
                        Calculation = RealWord * (0.0013568521031208 / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " mA"
                End Function
            End Class
            Public Class PR53_7
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 7, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer, Calibration As Integer) As String
                    'Notice: A Calibration Value of 6184 is typically a good starting place for a Calibration Value
                    Dim RealWord As Integer = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Calibration < 6000 Or Calibration > 7000 Then Calibration = 6184
                    Dim ActualCalibration As Decimal = Calibration / 10000000
                    If Scale = 0 Then
                        Calculation = RealWord * ActualCalibration
                    Else
                        Calculation = RealWord * (ActualCalibration / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " mA"
                End Function
            End Class
            Public Class PR53_9
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 9, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Integer = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Scale = 0 Then
                        Calculation = RealWord * 0.000345
                    Else
                        Calculation = RealWord * (0.000345 / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " VDC"
                End Function
            End Class
            Public Class PR53_14
                Public Shared Function StorePowerUpDefaultOptions(ByRef ncdObj As NCDEnterprise.NCDController, RecoveryMethod As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7633, 16)
                    If I IsNot Nothing Then
                        Dim Menu As Byte = RecoveryMethod
                        I(0) = Menu
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7633, I)
                    End If
                End Function
                Public Shared Function StorePowerUpDefaultState(ByRef ncdObj As NCDEnterprise.NCDController, DAC1 As Integer, DAC2 As Integer, DAC3 As Integer, DAC4 As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7600, 16)
                    If I IsNot Nothing Then
                        I(8) = NCDLib.Math.GetMSB(DAC1)
                        I(9) = NCDLib.Math.GetLSB(DAC1)
                        I(10) = NCDLib.Math.GetMSB(DAC2)
                        I(11) = NCDLib.Math.GetLSB(DAC2)
                        I(12) = NCDLib.Math.GetMSB(DAC3)
                        I(13) = NCDLib.Math.GetLSB(DAC3)
                        I(14) = NCDLib.Math.GetMSB(DAC4)
                        I(15) = NCDLib.Math.GetLSB(DAC4)
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7600, I)
                    End If
                End Function
                Public Shared Function SetOutputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Value As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 14, StartChannel, StopChannel, NCDLib.Math.GetMSB(Value), NCDLib.Math.GetLSB(Value))
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 14, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Decimal = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Scale = 0 Then
                        Calculation = RealWord * 0.0014015416958655
                    Else
                        Calculation = RealWord * (0.0014015416958655 / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " mA"
                End Function
            End Class
            Public Class PR53_11
                Public Shared Function IdentifyDevice(ByRef ncdObj As NCDEnterprise.NCDController)
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 11, 0)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 7)
                    Return Result
                End Function
                Public Shared Function ReadCurrent(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 3
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 11, StartChannel, StopChannel)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
            End Class
            Public Class PR53_37

            End Class
            Public Class PR53_33
                Public Shared Function StorePowerUpDefaultOptions(ByRef ncdObj As NCDEnterprise.NCDController, RecoveryMethod As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7632, 16)
                    If I IsNot Nothing Then
                        Dim Menu As Byte = RecoveryMethod
                        I(0) = Menu
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7632, I)
                    End If
                End Function
                Public Shared Function StorePowerUpDefaultState(ByRef ncdObj As NCDEnterprise.NCDController, DAC1 As Integer, DAC2 As Integer, DAC3 As Integer, DAC4 As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7616, 16)
                    If I IsNot Nothing Then
                        I(8) = NCDLib.Math.GetMSB(DAC1)
                        I(9) = NCDLib.Math.GetLSB(DAC1)
                        I(10) = NCDLib.Math.GetMSB(DAC2)
                        I(11) = NCDLib.Math.GetLSB(DAC2)
                        I(12) = NCDLib.Math.GetMSB(DAC3)
                        I(13) = NCDLib.Math.GetLSB(DAC3)
                        I(14) = NCDLib.Math.GetMSB(DAC4)
                        I(15) = NCDLib.Math.GetLSB(DAC4)
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7616, I)
                    End If
                End Function
                Public Shared Function SetOutputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Value As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    If Value > 15250 Then Value = 15250
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 33, StartChannel, StopChannel, NCDLib.Math.GetMSB(Value), NCDLib.Math.GetLSB(Value))
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 33, StartChannel, StopChannel)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Decimal = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Scale = 0 Then
                        Calculation = RealWord * 0.0014015416958655
                    Else
                        Calculation = RealWord * (0.0014015416958655 / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " mA"
                End Function
            End Class

        End Class



        Public Class Hardware
            Public Class I2C
                Public Shared I2CError As String

                Public Class Chip

                    Public Class AS1115
                        Public Shared Sub Display(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, A As Integer, B As Integer, C As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &H9, &H7)
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &HA, &HFF)
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &HC, &H1)
                            'NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &HE, &H0)
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &HB, &H3)
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &H1, A)
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &H2, B)
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &H3, C)
                        End Sub
                    End Class

                    Public Class PCA9685
                        Public Shared Sub Setup(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Frequency As Integer)
                            Dim Result As Byte()
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H0, &H0)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H0, &H10)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &HFE, &H5)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H0, &H0)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H0, 161)
                        End Sub
                        Public Shared Function SetChannel(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer, Value As Integer)
                            Dim Result As Byte()
                            If Channel = 1 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 6, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 2 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 10, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 3 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 14, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 4 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 18, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                            If Channel = 5 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 22, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 6 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 26, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 7 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 30, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 8 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 34, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                            If Channel = 9 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 38, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 10 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 42, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 11 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 46, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 12 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 50, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                            If Channel = 13 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 54, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 14 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 58, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 15 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 62, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 16 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 66, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                            Return Result
                        End Function
                    End Class

                    Public Class ADS7828

                        Public Shared Function Read_Channel(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer)

                            If Channel > 7 Then GoTo InvalidSettings

                            Dim CRG As Integer
                            Dim BitChannel As Integer
                            '                         Dim BitConversion As Integer = 16  'Conversion Mode =    Bit 4 = 1

                            Dim SD As Byte = 128    'Bit 7
                            Dim C2 As Byte = 64     'Bit 6
                            Dim C1 As Byte = 32     'Bit 5
                            Dim C0 As Byte = 16     'Bit 4
                            Dim PD1 As Byte = 0     'Bit 3
                            Dim PD0 As Byte = 4     'Bit 2
                            'Bits 0 and 1 are Not Allocated

                            'Channel = 0 to 7                Bit 6-5
                            If Channel = 0 Then BitChannel = (C2 * 0) + (C1 * 0) + (C0 * 0)
                            If Channel = 1 Then BitChannel = (C2 * 1) + (C1 * 0) + (C0 * 0)
                            If Channel = 2 Then BitChannel = (C2 * 0) + (C1 * 0) + (C0 * 1)
                            If Channel = 3 Then BitChannel = (C2 * 1) + (C1 * 0) + (C0 * 1)
                            If Channel = 4 Then BitChannel = (C2 * 0) + (C1 * 1) + (C0 * 0)
                            If Channel = 5 Then BitChannel = (C2 * 1) + (C1 * 1) + (C0 * 0)
                            If Channel = 6 Then BitChannel = (C2 * 0) + (C1 * 1) + (C0 * 1)
                            If Channel = 7 Then BitChannel = (C2 * 1) + (C1 * 1) + (C0 * 1)


                            CRG = SD + BitChannel + PD1 + PD0

                            'Debug.Print("-----------CRG----------- " + CRG.ToString)
                            'Debug.Print(NCDLib.Math.DecToBinaryStringStandard(CRG))

                            'Dim result1() As Byte = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, CRG)
                            'Dim result2() As Byte = NCDLib.Enterprise.Hardware.I2C.Read(ncdObj, I2CPort, Address, 2)

                            Dim result2() As Byte = NCDLib.Enterprise.Hardware.I2C.WriteRead(ncdObj, I2CPort, Address, 2, 0, CRG)

                            If Not (result2 Is Nothing) Then
                                If (result2.Length = 2) Then
                                    Dim d As Long
                                    d = (result2(0) * 256) + result2(1)
                                    Debug.Print(d.ToString)
                                    Read_Channel = d
                                    Return Read_Channel
                                End If
                            End If
                            Return -1

InvalidSettings:
                            Debug.Print("---------------------------------------------------")
                            Debug.Print("ERROR: ADS7828 Invalid Parameters")
                            If Channel > 7 Then Debug.Print("ERROR: ADS7828 Invalid Channel")
                            'If Resolution > 2 Then Debug.Print("ERROR: ADS7828 Invalid Resolution")
                            'If Gain > 3 Then Debug.Print("ERROR: ADS7828 Invalid Gain")
                            Debug.Print("---------------------------------------------------")

                        End Function

                    End Class

                    Public Class MCP3428
                        Public Shared Sub SetChannelResolutionGain(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)

                            If Channel > 3 Then GoTo InvalidSettings
                            If Resolution > 2 Then GoTo InvalidSettings
                            If Gain > 3 Then GoTo InvalidSettings

                            Dim CRG As Integer
                            Dim BitChannel As Integer
                            Dim BitConversion As Integer = 16  'Conversion Mode =    Bit 4 = 1
                            Dim BitResolution As Integer
                            Dim BitGain As Integer

                            'Channel = 0 to 3                Bit 6-5
                            If Channel = 0 Then BitChannel = 0
                            If Channel = 1 Then BitChannel = 32
                            If Channel = 2 Then BitChannel = 64
                            If Channel = 3 Then BitChannel = 96

                            'Resolution = 0 to 2  Bit 3-2
                            If Resolution = 0 Then BitResolution = 0    '12-Bit Resolution
                            If Resolution = 1 Then BitResolution = 4    '14-Bit Resolution
                            If Resolution = 2 Then BitResolution = 8    '16-Bit Resolution

                            'Gain = 0 to 3        Bit 1-0
                            If Gain = 0 Then BitGain = 0    'x1 Gain
                            If Gain = 1 Then BitGain = 1    'x2 Gain
                            If Gain = 2 Then BitGain = 2    'x4 Gain
                            If Gain = 3 Then BitGain = 3    'x8 Gain
                            '0 + 8 + 1 + 16
                            CRG = BitChannel + BitConversion + BitResolution + BitGain

                            'Debug.Print("-----------CRG----------- " + Channel.ToString)
                            'Debug.Print(NCDLib.Math.DecToBinaryStringStandard(CRG))

                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, CRG)

                            Exit Sub

InvalidSettings:
                            Debug.Print("---------------------------------------------------")
                            Debug.Print("ERROR: MCP3428 Invalid Parameters")
                            If Channel > 3 Then Debug.Print("ERROR: MCP3428 Invalid Channel")
                            If Resolution > 2 Then Debug.Print("ERROR: MCP3428 Invalid Resolution")
                            If Gain > 3 Then Debug.Print("ERROR: MCP3428 Invalid Gain")
                            Debug.Print("---------------------------------------------------")
                        End Sub

                        '  Public Shared Sub Setup_Channel(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)
                        '
                        '      NCDLib.Enterprise.Hardware.I2C.Chip.MCP3428.SetChannelResolutionGain(ncdObj, I2CPort, Address, Channel, Resolution, Gain)
                        '
                        '  End Sub

                        ' Public Shared Function Read_Channel_OLD(ByRef ncdObj As NCDEnterprise.NCDController, Port As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)
                        '
                        '
                        '     NCDLib.Enterprise.Hardware.I2C.Chip.MCP3428.SetChannelResolutionGain(ncdObj, Port, Address, Channel, Resolution, Gain)
                        '
                        '     'Wait for I2C Chip to Finish ADC Conversion
                        '     If Resolution = 2 Then
                        '         ncdObj.Sleep(66) ' Delay 1/15th Second
                        '     End If
                        '
                        '     Dim result() As Byte = NCDLib.Enterprise.Hardware.I2C.Read(ncdObj, Port, Address, 2)
                        '
                        '     If Not (result Is Nothing) Then
                        '         If (result.Length = 3) Then
                        '             Dim d As Long
                        '
                        '             'Debug.Print("---------Resolution---" + Resolution.ToString)
                        '
                        '             If Resolution = 0 Then
                        '                 'Debug.Print("12-Bit Resolution")
                        '                 d = (result(1) And &HF) * 256 + result(2) '(result(1) * 256 + result(2))
                        '             Else
                        '                 ' Debug.Print("High Resolution")
                        '                 d = (result(1) * 256) + result(2) '(result(1) * 256 + result(2))
                        '             End If
                        '             Debug.Print(d.ToString)
                        '             Read_Channel_OLD = d
                        '             Return Read_Channel_OLD
                        '         End If
                        '     End If
                        '     Return -1
                        '
                        ' End Function

                        Public Shared Function Read_Channel(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)

                            If Channel > 3 Then GoTo InvalidSettings
                            If Resolution > 2 Then GoTo InvalidSettings
                            If Gain > 3 Then GoTo InvalidSettings

                            Dim CRG As Integer
                            Dim BitChannel As Integer
                            Dim BitConversion As Integer = 16  'Conversion Mode =    Bit 4 = 1
                            Dim BitResolution As Integer
                            Dim BitGain As Integer

                            'Channel = 0 to 3                Bit 6-5
                            If Channel = 0 Then BitChannel = 0
                            If Channel = 1 Then BitChannel = 32
                            If Channel = 2 Then BitChannel = 64
                            If Channel = 3 Then BitChannel = 96

                            'Resolution = 0 to 2  Bit 3-2
                            If Resolution = 0 Then BitResolution = 0    '12-Bit Resolution
                            If Resolution = 1 Then BitResolution = 4    '14-Bit Resolution
                            If Resolution = 2 Then BitResolution = 8    '16-Bit Resolution

                            'Gain = 0 to 3        Bit 1-0
                            If Gain = 0 Then BitGain = 0    'x1 Gain
                            If Gain = 1 Then BitGain = 1    'x2 Gain
                            If Gain = 2 Then BitGain = 2    'x4 Gain
                            If Gain = 3 Then BitGain = 3    'x8 Gain
                            '0 + 8 + 1 + 16
                            CRG = BitChannel + BitConversion + BitResolution + BitGain

                            'Debug.Print("-----------CRG----------- " + Channel.ToString)
                            'Debug.Print(NCDLib.Math.DecToBinaryStringStandard(CRG))

                            Dim result() As Byte = NCDLib.Enterprise.Hardware.I2C.WriteRead(ncdObj, I2CPort, Address, 2, 22, CRG)

                            If Not (result Is Nothing) Then
                                If (result.Length = 2) Then
                                    Dim d As Long
                                    If Resolution = 0 Then
                                        'Debug.Print("12-Bit Resolution")
                                        d = (result(0) And &HF) * 256 + result(1) '(result(1) * 256 + result(2))
                                    Else
                                        ' Debug.Print("High Resolution")
                                        d = (result(0) * 256) + result(1) '(result(1) * 256 + result(2))
                                    End If
                                    Debug.Print(d.ToString)
                                    Read_Channel = d
                                    Return Read_Channel
                                End If
                            End If
                            Return -1

InvalidSettings:
                            Debug.Print("---------------------------------------------------")
                            Debug.Print("ERROR: MCP3428 Invalid Parameters")
                            If Channel > 3 Then Debug.Print("ERROR: MCP3428 Invalid Channel")
                            If Resolution > 2 Then Debug.Print("ERROR: MCP3428 Invalid Resolution")
                            If Gain > 3 Then Debug.Print("ERROR: MCP3428 Invalid Gain")
                            Debug.Print("---------------------------------------------------")

                        End Function

                    End Class

                End Class

                Public Shared Function Read(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, RXBytes As Integer) As Byte()

                    Dim aI(4) As Byte

                    I2CError = ""

                    aI(0) = 189                  'Byte 0
                    aI(1) = I2CPort              'Byte 1
                    aI(2) = 191                  'Byte 2
                    aI(3) = Address              'Byte 3
                    aI(4) = RXBytes              'Byte 4

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function
                Public Shared Function Write(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()

                    Dim TransmitCount As Integer = TXDAT.Length
                    Dim aI(TransmitCount + 3) As Byte

                    I2CError = ""
                    aI(0) = 189                  'Byte 0
                    aI(1) = I2CPort              'Byte 1
                    aI(2) = 190                  'Byte 2
                    aI(3) = Address              'Byte 3
                    For i1 As Integer = 0 To TransmitCount - 1
                        aI(i1 + 4) = TXDAT(i1) 'Int(txArray(i1).Text)
                    Next

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    Debug.Print("-------------- I2C Write Command:")
                    For Each a In aI
                        Debug.Print(a)
                    Next
                    Debug.Print("-------------- END Command")


                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = ("I2C Write - Error Package:")
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If

                End Function
                Public Shared Function WriteLite(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()

                    Dim TransmitCount As Integer = TXDAT.Length
                    Dim aI(TransmitCount + 1) As Byte

                    I2CError = ""
                    aI(0) = 190                  'Byte 2
                    aI(1) = Address              'Byte 3
                    For i1 As Integer = 0 To TransmitCount - 1
                        aI(i1 + 2) = TXDAT(i1) 'Int(txArray(i1).Text)
                    Next

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    Debug.Print("-------------- I2C Write Command:")
                    For Each a In aI
                        Debug.Print(a)
                    Next
                    Debug.Print("-------------- END Command")


                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = ("I2C Write - Error Package:")
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If

                End Function
                Public Shared Function WriteRead(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, RXBytes As Integer, Delay As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()

                    Dim TransmitCount As Integer = TXDAT.Length
                    Dim aI(TransmitCount + 5) As Byte

                    I2CError = ""
                    aI(0) = 189                  'Byte 0
                    aI(1) = I2CPort              'Byte 1
                    aI(2) = 192                  'Byte 2
                    aI(3) = Address              'Byte 3
                    aI(4) = RXBytes              'Byte 4
                    aI(5) = Delay                'Byte 5
                    For i1 As Integer = 0 To TransmitCount - 1
                        aI(i1 + 6) = TXDAT(i1) 'Int(txArray(i1).Text)
                    Next

                    Debug.Print("DUMP BEGIN")
                    For Temp As Integer = 0 To aI.Length - 1
                        Debug.Print(aI(Temp).ToString)
                    Next
                    Debug.Print("DUMP END")

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function

                Public Shared Function Scan(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                    Dim aI(4) As Byte

                    '189 2 192 0

                    I2CError = ""

                    aI(0) = 189                  'Select I2C Port Command
                    aI(1) = I2CPort              'Port Selection
                    aI(2) = 193                  'Byte 0 Updated I2C Scan
                    aI(3) = 0                    'Byte 1

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)

                    If (Not (rData Is Nothing)) Then
                        Debug.Print("-------------- I2C Scan Command:")
                        For Each a In rData
                            Debug.Print(a)
                        Next
                        Debug.Print("-------------- END Command")
                    End If


                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function
                Public Shared Function PortSet(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                    Dim aI(2) As Byte

                    I2CError = ""
                    aI(0) = 188                  'Byte 0
                    aI(1) = I2CPort              'Byte 1

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function

                Public Shared Function PortGet(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, RXBytes As Integer) As Byte()

                    Dim aI(2) As Byte

                    I2CError = ""
                    aI(0) = 188                  'Byte 0
                    aI(1) = 255                  'Byte 1


                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function

            End Class
        End Class


    End Class
End Class
