﻿Imports System.Reflection
Imports System.IO
Imports System.Windows.Forms
Imports NCDEnterprise

Partial Class NCDLib
    ' flag for high speed writting/reading. Be Careful, it only work with direct usb access
    Public Shared HighSpeed As Boolean = False

    Public Class I2CBasic
        Public Shared I2CError As String
        ' flag for high speed writting/reading. Be Careful, it only work with direct usb access
        Public Shared HighSpeed As Boolean = False

        Public Shared Sub SoftReset(ByRef ncdObj As NCDController)
            NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 188)
        End Sub
        Public Shared Sub HardReset(ByRef ncdObj As NCDController)
            NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 189)
        End Sub
        Public Shared Function Test2Way(ByRef ncdObj As NCDController)
            NCDLib.WriteBytesAPI(ncdObj, True, 254, 33)
            Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
            Debug.Print(Result)
            Return Result
        End Function
        Public Shared Function GetVersion(ByRef ncdObj As NCDEnterprise.NCDController)

            NCDLib.WriteBytesAPI(ncdObj, True, 254, 52, 240, 5)
            Dim SettingsSETUP As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 6)
            If SettingsSETUP IsNot Nothing Then
                'Baud.SelectedIndex = NCDLib.Safe.Limit_Value(SettingsSETUP(0), 0, 5)
                'UI.SelectedIndex = NCDLib.Safe.Limit_Value(SettingsSETUP(1), 0, 1)
                'CPUPriority.Value = NCDLib.Safe.Limit_Value(SettingsSETUP(2), 0, 255)
                If SettingsSETUP(5) > 0 Then
                    GetVersion = SettingsSETUP(5)
                    'StartupOptionsGroup.Visible = True
                    'FirmwareVersion.Text = "Release Firmware Version " + SettingsSETUP(5).ToString
                Else
                    'StartupOptionsGroup.Visible = False
                    GetVersion = 0
                End If
            End If

        End Function
        Public Shared Function Write(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()

            Dim TransmitCount As Integer = TXDAT.Length
            Dim aI(TransmitCount + 1) As Byte

            I2CError = ""
            aI(0) = 190                  'Byte 2
            aI(1) = Address              'Byte 3
            For i1 As Integer = 0 To TransmitCount - 1
                aI(i1 + 2) = TXDAT(i1) 'Int(txArray(i1).Text)
            Next

            NCDLib.WriteBytesAPI(ncdObj, True, aI)

            Debug.Print("-------------- I2C Write Command:")
            For Each a In aI
                Debug.Print(a)
            Next
            Debug.Print("-------------- END Command")


            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
            If (Not (rData Is Nothing)) Then
                If rData(0) = 4 Then    'If we received 4 bytes of data
                    If rData(1) = 188 Then
                        If rData(4) = 67 Then
                            I2CError = ("I2C Write - Error Package:")
                            If rData(2) = 90 Then
                                If rData(3) = (255 - 90) Then
                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                End If
                            End If
                            If rData(2) = 91 Then
                                If rData(3) = (255 - 91) Then
                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                End If
                            End If
                            If rData(2) = 92 Then
                                If rData(3) = (255 - 92) Then
                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                End If
                            End If
                        End If
                    End If
                End If
                Return rData
            Else
                I2CError = ("NO DATA RECEIVED")
            End If

        End Function
        Public Shared Function Read(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, RXBytes As Integer) As Byte()

            Dim aI(2) As Byte

            I2CError = ""

            aI(0) = 191                  'Byte 2
            aI(1) = Address              'Byte 3
            aI(2) = RXBytes              'Byte 4
            NCDLib.WriteBytesAPI(ncdObj, True, aI)
            '------------------------------------------------------------------------------------------
            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
            If (Not (rData Is Nothing)) Then
                If rData(0) = 4 Then    'If we received 4 bytes of data
                    If rData(1) = 188 Then
                        If rData(4) = 67 Then
                            I2CError = "I2C Read - Error Package:"
                            If rData(2) = 90 Then
                                If rData(3) = (255 - 90) Then
                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                End If
                            End If
                            If rData(2) = 91 Then
                                If rData(3) = (255 - 91) Then
                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                End If
                            End If
                            If rData(2) = 92 Then
                                If rData(3) = (255 - 92) Then
                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                End If
                            End If
                        End If
                    End If
                End If
                Return rData
            Else
                I2CError = ("NO DATA RECEIVED")
            End If
        End Function
        Public Shared Function WriteRead(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, RXBytes As Integer, Delay As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()

            Dim TransmitCount As Integer = TXDAT.Length
            Dim aI(TransmitCount + 3) As Byte

            I2CError = ""
            ' aI(0) = 189                  'Byte 0
            ' aI(1) = I2CPort              'Byte 1
            aI(0) = 192                  'Byte 2
            aI(1) = Address              'Byte 3
            aI(2) = RXBytes              'Byte 4
            aI(3) = Delay                'Byte 5
            For i1 As Integer = 0 To TransmitCount - 1
                aI(i1 + 4) = TXDAT(i1) 'Int(txArray(i1).Text)
            Next

            Debug.Print("DUMP BEGIN")
            For Temp As Integer = 0 To aI.Length - 1
                Debug.Print(aI(Temp).ToString)
            Next
            Debug.Print("DUMP END")

            NCDLib.WriteBytesAPI(ncdObj, True, aI)
            '------------------------------------------------------------------------------------------
            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
            If (Not (rData Is Nothing)) Then
                If rData(0) = 4 Then    'If we received 4 bytes of data
                    If rData(1) = 188 Then
                        If rData(4) = 67 Then
                            I2CError = "I2C Read - Error Package:"
                            If rData(2) = 90 Then
                                If rData(3) = (255 - 90) Then
                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                End If
                            End If
                            If rData(2) = 91 Then
                                If rData(3) = (255 - 91) Then
                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                End If
                            End If
                            If rData(2) = 92 Then
                                If rData(3) = (255 - 92) Then
                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                End If
                            End If
                        End If
                    End If
                End If
                Return rData
            Else
                I2CError = ("NO DATA RECEIVED")
            End If
        End Function
        Public Shared Function Scan(ByRef ncdObj As NCDEnterprise.NCDController) As Byte()

            Dim aI(1) As Byte

            '189 2 192 0

            I2CError = ""

            'aI(0) = 189                  'Select I2C Port Command
            'aI(1) = I2CPort              'Port Selection
            aI(0) = 193                  'Byte 0 Updated I2C Scan
            aI(1) = 0                    'Byte 1

            NCDLib.WriteBytesAPI(ncdObj, True, aI)

            '------------------------------------------------------------------------------------------
            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)

            If (Not (rData Is Nothing)) Then
                Debug.Print("-------------- I2C Scan Command:")
                For Each a In rData
                    Debug.Print(a)
                Next
                Debug.Print("-------------- END Command")
            End If


            If (Not (rData Is Nothing)) Then
                If rData(0) = 4 Then    'If we received 4 bytes of data
                    If rData(1) = 188 Then
                        If rData(4) = 67 Then
                            I2CError = "I2C Read - Error Package:"
                            If rData(2) = 90 Then
                                If rData(3) = (255 - 90) Then
                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                End If
                            End If
                            If rData(2) = 91 Then
                                If rData(3) = (255 - 91) Then
                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                End If
                            End If
                            If rData(2) = 92 Then
                                If rData(3) = (255 - 92) Then
                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                End If
                            End If
                        End If
                    End If
                End If
                Return rData
            Else
                I2CError = ("NO DATA RECEIVED")
            End If
        End Function

        Public Class Chip
            Public Class AS1115
                Public Shared Sub DisplayBrightness(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Brightness As Integer)
                    NCDLib.I2CBasic.Write(ncdObj, Address, &HA, Brightness)
                End Sub
                Public Shared Sub DisplayValue(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    Dim VString As String = "000"
                    Dim CH1 As Integer = 0
                    Dim CH2 As Integer = 0
                    Dim CH3 As Integer = 0
                    'Convert Value to 3 Digit String
                    VString = Value.ToString
                    If Len(VString) = 1 Then
                        VString = "00" + Value.ToString
                    Else
                        If Len(VString) = 2 Then
                            VString = "0" + Value.ToString
                        End If
                    End If
                    'Extract Each Digit and Send to Display as 3 Bytes (Left to Right)
                    CH1 = Mid(VString, 1, 1) 'Left Digit
                    CH2 = Mid(VString, 2, 1) 'Center Digit
                    CH3 = Mid(VString, 3, 1) 'Right Digit
                    NCDLib.I2CBasic.Write(ncdObj, Address, &H1, CH1, CH2, CH3)
                End Sub
            End Class
            Public Class PCA8574_Display
                Public Shared DisplayByte As Byte
                Public Shared Sub BacklightOn(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    'Backlight = Bit 3 (Value = 8)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 3, 1)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteByte(ncdObj, Address, DisplayByte)
                End Sub
                Public Shared Sub BacklightOff(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    'Backlight = Bit 3 (Value = 8)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 3, 0)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteByte(ncdObj, Address, DisplayByte)
                End Sub
                Public Shared Sub DisplayOffCursorOff(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H8)
                End Sub
                Public Shared Sub DisplayOnCursorUnderline(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &HE)
                End Sub
                Public Shared Sub DisplayOnCursorOff(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &HC)
                End Sub
                Public Shared Sub DisplayOnCursorBlock(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &HF)
                End Sub
                Public Shared Sub DisplayShiftLeft(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H18)
                End Sub
                Public Shared Sub DisplayShiftRight(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H1C)
                End Sub
                Public Shared Sub CursorLeft(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H10)
                End Sub
                Public Shared Sub CursorRight(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H14)
                End Sub
                Public Shared Sub ClearDisplay(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H1)
                End Sub
                Public Shared Sub HomeCursor(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H2)
                End Sub
                Public Shared Sub Line1_20x4(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H80)
                End Sub
                Public Shared Sub Line2_20x4(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &HC0)
                End Sub
                Public Shared Sub Line3_20x4(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H94)
                End Sub
                Public Shared Sub Line4_20x4(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &HD4)
                End Sub
                Public Shared Sub Text(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, DisplayText As String, Limit As Integer)
                    Dim Letter As Integer
                    If DisplayText IsNot Nothing Then
                        For Count = 1 To NCDLib.Safe.Limit_Value(Len(DisplayText), 1, Limit)
                            Letter = Asc(Mid(DisplayText, Count, 1))
                            Debug.Print(Count.ToString + " " + Letter.ToString)
                            NCDLib.I2CBasic.Chip.PCA8574_Display.WriteData(ncdObj, Address, Letter)
                        Next
                    End If
                End Sub
                Public Shared Sub Initialize20x4(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    DisplayByte = 2
                    'DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.BacklightOn(ncdObj, Address)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 3)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 3)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 3)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 2)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 2)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 8)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 0)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 8)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 0)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 1)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 0)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 6)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 0)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 15)
                End Sub

                Public Shared Sub WriteCommand(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteUpperNibble(ncdObj, Address, Value)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, Value)
                End Sub

                Public Shared Sub WriteData(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 1) 'RS Line = High (Data Mode)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteUpperNibble(ncdObj, Address, Value)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, Value)
                End Sub
                Public Shared Sub WriteLowerNibble(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    'DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 1, 0) 'RW Line = Low
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 1) 'E  Line = High
                    'This Bit is Reserved for the Backlight Control Line
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 4, NCDLib.Math.GetBit(Value, 0)) 'D0
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 5, NCDLib.Math.GetBit(Value, 1)) 'D1
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 6, NCDLib.Math.GetBit(Value, 2)) 'D2
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 7, NCDLib.Math.GetBit(Value, 3)) 'D3
                    '   NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                    '   DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = High
                    NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = Low
                    NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                End Sub
                Public Shared Sub WriteUpperNibble(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    ' DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 1, 0) 'RW Line = Low
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 1) 'E  Line = High
                    'This Bit is Reserved for the Backlight Control Line
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 4, NCDLib.Math.GetBit(Value, 4)) 'D4
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 5, NCDLib.Math.GetBit(Value, 5)) 'D5
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 6, NCDLib.Math.GetBit(Value, 6)) 'D6
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 7, NCDLib.Math.GetBit(Value, 7)) 'D7
                    '   NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                    '   DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = High
                    NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = Low
                    NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                End Sub


                Public Shared Sub WriteByte(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    Debug.Print(NCDLib.Math.DecToBinaryStringStandard(Value))
                    NCDLib.I2CBasic.Write(ncdObj, Address, Value)
                End Sub
            End Class
            Public Class TCA9546
                Public Shared Sub ChannelSelect(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Channel As Integer)
                    'Default Address of PCA9546 is &H70
                    Select Case Channel
                        Case 1 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 1)
                        Case 2 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 2)
                        Case 3 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 4)
                        Case 4 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 8)
                    End Select
                End Sub
            End Class
            Public Class PCA9547
                Public Shared Sub ChannelSelect(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Channel As Integer)
                    'Default Address of PCA7547 is &H70
                    Select Case Channel
                        Case 1 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 8)
                        Case 2 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 9)
                        Case 3 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 10)
                        Case 4 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 11)
                        Case 5 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 12)
                        Case 6 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 13)
                        Case 7 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 14)
                        Case 8 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 15)
                    End Select
                End Sub
            End Class
        End Class
    End Class
End Class
