﻿Public Class frmRelayStatusMap
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public FormLoading As Boolean = True
    Private Sub StartAddress_ValueChanged(sender As Object, e As EventArgs) Handles StartAddress.ValueChanged
        If FormLoading = False Then
            FillTableA()
        End If
    End Sub
    Public Sub FillTableA()
        Dim I(15) As Byte
        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress.Value, 16)
        If I IsNot Nothing Then
            For Y As Integer = 0 To 15
                Dim Address As Double = StartAddress.Value + Y
                Dim Hex_Value As String
                Hex_Value = Hex(Address)
                CellData(0, Y, Address.ToString + "-" + Hex_Value)
                CellData(1, Y, Hex(I(Y)).ToString)
                CellData(2, Y, I(Y).ToString)
                CellData(3, Y, NCDLib.Math.DecToBinaryStringStandard(I(Y)))
                CellData(4, Y, NCDLib.Enterprise.ProXR.Menu.GetDescription(Address))
            Next Y
        End If
    End Sub
    Public Sub CellData(x As Integer, Y As Integer, Dat As String)
        DataTable(x, Y).Value = Dat
    End Sub
    Public Function GetCellData(x As Integer, Y As Integer) As String
        GetCellData = DataTable(x, Y).Value
    End Function
    Private Sub Refresh_Click(sender As Object, e As EventArgs) Handles Refresh.Click
        If FormLoading = False Then
            FillTableA()
        End If
    End Sub

    Private Sub ErrorFlags_Click(sender As Object, e As EventArgs) Handles ErrorFlags.Click
        StartAddress.Value = 1024
    End Sub

    Private Sub frmRelayStatusMap_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        For Temp As Integer = 1 To 16
            DataTable.Rows.Add()
        Next Temp
        FillTableA()
        FormLoading = False
    End Sub

    Private Sub ChangePort_ValueChanged(sender As Object, e As EventArgs) Handles ChangePort.ValueChanged
        Select Case ChangePort.Value
            Case 1 : StartAddress.Value = 0
            Case 2 : StartAddress.Value = 16
            Case 3 : StartAddress.Value = 32
            Case 4 : StartAddress.Value = 48
            Case 5 : StartAddress.Value = 64
            Case 6 : StartAddress.Value = 80
            Case 7 : StartAddress.Value = 96
            Case 8 : StartAddress.Value = 112
            Case 9 : StartAddress.Value = 128
            Case 10 : StartAddress.Value = 144
            Case 11 : StartAddress.Value = 160
            Case 12 : StartAddress.Value = 176
            Case 13 : StartAddress.Value = 192
            Case 14 : StartAddress.Value = 208
            Case 15 : StartAddress.Value = 224
            Case 16 : StartAddress.Value = 240

        End Select
    End Sub

    Private Sub ClearErrors_Click(sender As Object, e As EventArgs) Handles ClearErrors.Click
        'Setup a Container for Data
        Dim I(15) As Byte
        For CellCount As Integer = 0 To 15
            I(CellCount) = 0
        Next CellCount
        'Store Container Array at the Selected Start Address
        NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, 1024, I)
        'Refresh Tables
        If FormLoading = False Then
            FillTableA()
        End If
    End Sub
End Class