﻿Public Class frmType27_AirQuality
    Private Sub frmType27_AirQuality_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Text = "Type 27 Air Quality Sensor - Address: " + SensorAddress

        Timer1.Interval = 3000
        Timer1.Start()
    End Sub
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public SensorAddress As String
    Public Shared DataFrame As New NCDLib.Wireless.S3B_API.SensorData
    Public Shared Type27 As New NCDLib.Wireless.S3B_API.SensorData.TypeData.Type27
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        'Receive Data from Wireless Sensor
        DataFrame = NCDLib.Wireless.S3B_API.SensorDataCapture(NCDComponent1, SensorAddress)

        'Parse Data
        If (DataFrame.Valid) Then
            Waiting.Visible = False
            BatteryLevel.Value = DataFrame.BatteryInt   'Show Battery Progress Bar
            Battery.Text = DataFrame.Battery            'Show Battery Voltage in Text Box
            NODEID.Text = DataFrame.NodeID              'Show Device Node ID Data
            Address.Text = SensorAddress                'Show Sensor Address
            Counter.Text = DataFrame.Counter.ToString   'Show Transmission Cycle Counter
            SensorType.Text = DataFrame.SensorType.ToString 'Show Sensor Type
            SensorInfo.Text = DataFrame.Description     'Show Sensor Description
            Firmware.Text = DataFrame.Firmware          'Show Firmware Version
            Summary.Text = DataFrame.SensorReadings     'Show a Summary View of All Sensor Data

            CompleteFrame.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompleteFrame)
            CompletePayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompletePayload)
            SensorPayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.SensorPayload)

            Celsius.Text = Type27.Celsius
            Fahrenheit.Text = Type27.Fahrenheit
            Humidity.Text = Type27.Humidity
            Pressure.Text = Type27.Pressure


            If Type27.GasReady = True Then
                GAS.Text = Type27.Gas
                IAQ.Text = Type27.IAQ
                NotReadyHelp.Visible = False
            Else
                GAS.Text = "NOT READY"
                IAQ.Text = "NOT READY"
                NotReadyHelp.Visible = True
            End If


        End If
    End Sub
    Private Sub frmfrmType27_TemperatureHumidity_Load(sender As Object, e As EventArgs) Handles MyBase.Closed

        Timer1.Stop()

    End Sub

End Class