﻿Public Class frmType32_ParticulateMatter
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public SensorAddress As String
    Public Shared DataFrame As New NCDLib.Wireless.S3B_API.SensorData
    Public Shared Type32 As New NCDLib.Wireless.S3B_API.SensorData.TypeData.Type32
    Private Sub frmType32_ParticulateMatter_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Text = "Type 32 Particulate Matter Sensor - Address: " + SensorAddress
        Timer1.Interval = 3000
        Timer1.Start()
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        'Receive Data from Wireless Sensor
        DataFrame = NCDLib.Wireless.S3B_API.SensorDataCapture(NCDComponent1, SensorAddress)

        'Parse Data
        If (DataFrame.Valid) Then
            Waiting.Visible = False
            BatteryLevel.Value = DataFrame.BatteryInt   'Show Battery Progress Bar
            Battery.Text = DataFrame.Battery            'Show Battery Voltage in Text Box
            NODEID.Text = DataFrame.NodeID              'Show Device Node ID Data
            Address.Text = SensorAddress                'Show Sensor Address
            Counter.Text = DataFrame.Counter.ToString   'Show Transmission Cycle Counter
            SensorType.Text = DataFrame.SensorType.ToString 'Show Sensor Type
            SensorInfo.Text = DataFrame.Description     'Show Sensor Description
            Firmware.Text = DataFrame.Firmware          'Show Firmware Version
            Summary.Text = DataFrame.SensorReadings     'Show a Summary View of All Sensor Data

            CompleteFrame.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompleteFrame)
            CompletePayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompletePayload)
            SensorPayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.SensorPayload)

            MC_PM1_0.Text = Type32.MassConcentration_PM1_0
            MC_PM2_5.Text = Type32.MassConcentration_PM2_5
            MC_PM4_0.Text = Type32.MassConcentration_PM4_0
            MC_PM10_0.Text = Type32.MassConcentration_PM10_0

            NC_PM0_5.Text = Type32.NumberConcentration_PM0_5
            NC_PM1_0.Text = Type32.NumberConcentration_PM1_0
            NC_PM2_5.Text = Type32.NumberConcentration_PM2_5
            NC_PM4_0.Text = Type32.NumberConcentration_PM4_0
            NC_PM10_0.Text = Type32.NumberConcentration_PM10_0

            TypicalParticleSize.Text = Type32.TypicalParticleSize

            Humidity.Text = Type32.Humidity
            Celsius.Text = Type32.Celsius
            Fahrenheit.Text = Type32.Fahrenheit

        End If

    End Sub

    Private Sub frmfrmType32_ParticulateMatter_Load(sender As Object, e As EventArgs) Handles MyBase.Closed

        Timer1.Stop()

    End Sub


End Class